function [Pop,FE] = ComplementaryEnvironmentalSelection(Pop,Arc,W,FE,problem,Boundary)

[N,m] = size(W);
D = size(Pop,2)-m;
Z = zeros(1,m);
% the first reproduction and selection
OffPopX = GAonce(Pop(:,1:D),Arc(:,1:D),Boundary);
OffPopX = unique(OffPopX,'rows');

% Evaluzation
obj = LSMOP('value',problem,m,OffPopX,D);
FE = FE + size(obj,1);
OffPop = [OffPopX,obj];

% Environmental Selection
PopCom = [Pop;Arc;OffPop];
Pop = EnvironmentSelectionDecomposition(PopCom,W);
if size(Pop,1)< (2/3)*N
    Pop = EnvironmentalSelectionNSGAII(PopCom,N,m);
end

%the second reproduction and selection
OffPopX = GA(Pop(:,1:D),Boundary,N);
obj = LSMOP('value',problem,m,OffPopX,D);
FE = FE + size(obj,1);
OffPop = [OffPopX,obj];
PopCom = [Pop;OffPop];

Pop = EnvironmentSelectionDecomposition(PopCom,W);
if size(Pop,1)<(2/3)*N
    Pop = EnvironmentalSelectionNSGAII(PopCom,N,m);
end
end

